## mingw-w64-mtn-3.5.0-3.src.tar.zst

=== src/Makefile ===
#CFLAGS=-W -Wall -O3 -s -D_FILE_OFFSET_BITS=64 -mtune=i686 -march=i386 -I/home/tuitfun/include -L/home/tuitfun/lib
#CFLAGS=-W -Wall `pkg-config --cflags libavformat`

# The DESTDIR is macro is used for staged builds, so that it gets installed
# under a fake root directory for the sake of packaging. Unlike PREFIX, it will
# not actually be run from this directory.
#DESTDIR - reserved for rpmbuild

# According to a convention, PREFIX macro is the prefix of instalation.
PREFIX = /usr/local

ENABLE_AVIF=1
ENABLE_WEBP=1

KERNELNAME=$(shell uname -s)
OSNAME=$(shell uname -o)
CFLAGS=-W -Wall $(USER_CFLAGS)
OUT=../bin
LIBSDIR=../lib

ifeq ($(KERNELNAME),FreeBSD)
LIBS+=-L/usr/local/lib
INCPATH+=-I/usr/local/include
endif

ifeq ($(KERNELNAME),Linux)
INCPATH=-I/usr/include/ffmpeg
LIBS+=$(shell pkg-config --libs-only-L libavutil)
endif

ifeq ($(OSNAME),Msys)
LIBS=-L/mingw64/lib
INCPATH=-I/mingw64/include
CFLAGS=-W
endif

ifeq ($(ENABLE_WEBP),1)
    CFLAGS+=-DMTN_WITH_WEBP
endif

ifeq ($(ENABLE_AVIF),1)
    CFLAGS+=-DMTN_WITH_AVIF
endif

LIBS+=-lavcodec -lavformat -lavcodec -lswscale -lavutil -lavfilter -lgd -lm
S_INCPATH=-I$(LIBSDIR)/FFmpeg -I$(LIBSDIR)/libgd/src
S_LIBS= -static-libgcc -static \
	$(LIBSDIR)/FFmpeg/libswscale/libswscale.a \
	$(LIBSDIR)/FFmpeg/libavcodec/libavcodec.a \
	$(LIBSDIR)/FFmpeg/libswresample/libswresample.a \
	$(LIBSDIR)/FFmpeg/libavformat/libavformat.a \
	$(LIBSDIR)/FFmpeg/libavfilter/libavfilter.a \
	$(LIBSDIR)/FFmpeg/libavutil/libavutil.a \
	$(LIBSDIR)/FFmpeg/libavcodec/libavcodec.a \
	$(LIBSDIR)/libgd/Bin/libgd.a \
    -lpthread -lbz2 -lfontconfig -lfreetype -lbrotlidec -lbrotlicommon -lexpat -ljpeg -lpng16 -lwebp -lz -lzimg -lm -lstdc++

mtn: mtn.c outdir
	$(CC) -o $(OUT)/mtn mtn.c $(INCPATH) $(CFLAGS) -O3 $(LIBS)

outdir:
	mkdir -p $(OUT)

static: mtn.c outdir
	$(CC) -o $(OUT)/mtn mtn.c $(S_INCPATH) $(CFLAGS) $(S_LIBS) -DMTN_STATIC

debug: mtn.c outdir
	$(CC) -o $(OUT)/mtn mtn.c $(INCPATH) $(CFLAGS) -W -Wall -g -DDEBUG $(LIBS)

clean:
	rm -f $(OUT)/mtn

distclean:
	rm -rf $(OUT)

rebuild:  clean mtn
rebuild_static: clean static

test_bin:
	$(OUT)/mtn -f ../test/font.ttf -h 50 -O /tmp /home/sample.avi
	test -s /tmp/sample_s.jpg

test:  rebuild  mtn  test_bin
static_test: rebuild_static static test_bin

install:
	mkdir -p $(DESTDIR)$(PREFIX)/bin/
	install -m 755 $(OUT)/mtn $(DESTDIR)$(PREFIX)/bin/
	mkdir -p $(DESTDIR)$(PREFIX)/share/doc/mtn
	cp -Rp ../doc/* $(DESTDIR)$(PREFIX)/share/doc/mtn
	cp -p ../LICENSE $(DESTDIR)$(PREFIX)/share/doc/mtn
	mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1
	cp -p ../man/mtn.1 $(DESTDIR)$(PREFIX)/share/man/man1/

uninstall:
	rm -f  $(DESTDIR)$(PREFIX)/share/man/man1/mtn.1
	rm -f  $(DESTDIR)$(PREFIX)/bin/mtn
	rm -rf $(DESTDIR)$(PREFIX)/share/doc/mtn

=== PKGBUILD ===
# Maintainer: wahibre <wahibre@gmx.com>

_realname=mtn
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=3.5.0
pkgrel=3
pkgdesc="Command line program to save thumbnails (screenshots) of movie or video files into jpeg/png files (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://gitlab.com/movie_thumbnailer/mtn"
license=('GPL2')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-make")
depends=("${MINGW_PACKAGE_PREFIX}-ffmpeg"
         "${MINGW_PACKAGE_PREFIX}-libgd")
source=("${url}/-/archive/v${pkgver}/${_realname}-v${pkgver}.tar.gz")
sha256sums=('0354e598dcbd3b7ac7f44e6c8b77699c5c7b51691b23e711513d785c3af06933')

build() {
  cd "${srcdir}/${_realname}-v${pkgver}/src"
  mingw32-make
}

package() {
  cd "${srcdir}/${_realname}-v${pkgver}/src"
  mkdir -p "${pkgdir}"/${MINGW_PREFIX}/bin/
  install -m 755 ../bin/mtn "${pkgdir}"/${MINGW_PREFIX}/bin/
  mkdir -p "${pkgdir}"/${MINGW_PREFIX}/share/man/man1
  cp -p ../man/mtn.1 "${pkgdir}"/${MINGW_PREFIX}/share/man/man1/
}

=== debian/control ===
Source: mtn
Section: utils
Priority: optional
Maintainer: wahibre <wahibre@gmx.com>
Build-Depends: debhelper(>=10),
               lsb-release,
               libgd-dev,
               libavutil-dev,
               libavcodec-dev,
               libavformat-dev,
               libavfilter-dev,
               libswscale-dev
Standards-Version: 4.1.2
Homepage: https://gitlab.com/movie_thumbnailer/mtn/wikis
Vcs-Bzr: lp:wahibre/mtn
Vcs-Browser: https://launchpad.net/~wahibre/+archive/ubuntu/mtn

Package: mtn
Architecture: any
Depends: ${shlibs:Depends}, 
         ${misc:Depends},
         fontconfig,
         fonts-dejavu-core
Suggests: mtn-bash-completion,
          mtn-zsh-completion
Description: Movie Thumbnailer - screens generator
 Movie Thumbnailer (mtn) saves thumbnails (screenshots) of movie or 
 video files to jpeg files. It uses FFmpeg's libavcodec as its engine, 
 so it supports all popular codecs.

Package: mtn-bash-completion
Architecture: any
Depends: mtn (>=3.4.0),
         bash-completion,
         fontconfig
Description: bash completion for Movie Thumbnailer - screens generator
 This package contains file for bash competions.

Package: mtn-zsh-completion
Architecture: any
Depends: mtn (>=3.4.0),
         zsh-common,
         fontconfig
Description: zsh completion for Movie Thumbnailer - screens generator
 This package contains file for zsh competions.
